/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.1  (April 7, 1998).                                                 *
*                                                                                    *
*  Definition of JPDividerGadget class.                                              *
*                                                                                    *
*  Read JPDIVGAD.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/
#include <owl/pch.h>

/*#if !defined(OWL_UIHELPER_H)
# include <owl/uihelper.h>
#endif*/
#if !defined(OWL_CELARRAY_H)
# include <owl/celarray.h>
#endif
#if !defined(OWL_GADGETWI_H)
# include <owl/gadgetwi.h>
#endif

#include "jpdivgad.h"


//{{JPDividerGadget Implementation}}


JPDividerGadget::JPDividerGadget(int size, int id, bool EndOfLine, bool NoVertBar)
:
    TGadget(id, None)
{
  // INSERT>> Your constructor code here.
  DrawOnVertBar   = NoVertBar;
  DrawAtEndOfLine = EndOfLine;
  ShrinkWrapWidth = true;
  ShrinkWrapHeight = true;
  TBorders borders;
  borders.Top = borders.Left = borders.Right = borders.Bottom = 1;
  SetBorders(borders);
  if ((!size) || (size < 6))
    size = 6;
  divSize = size;
}


JPDividerGadget::~JPDividerGadget()
{
  // INSERT>> Your destructor code here.

}


void JPDividerGadget::GetDesiredSize(TSize& size)
{
  TGadget::GetDesiredSize(size);

  // INSERT>> Your code here.
  if (Window)
     {
     size += Window->GetCelArray().CelSize();
     if (Window->GetDirection()==TGadgetWindow::Horizontal)
           size.cx = divSize;
     else
     if (Window->GetDirection()==TGadgetWindow::Vertical)
           size.cy = divSize;
     else
     if (Window->GetDirection()==TGadgetWindow::Rectangular)
           size.cx = divSize;
     }
}

void JPDividerGadget::DrawDividerLine(TDC& dc, int x1, int y1, int x2, int y2, bool isFirst)
{
     TPen pen (isFirst ? TColor::Sys3dShadow : TColor::Sys3dHilight);
     dc.SelectObject(pen);
     dc.MoveTo(x1, y1);
     dc.LineTo(x2, y2);
     dc.RestorePen();
}

void JPDividerGadget::Paint(TDC& dc)
{
  // INSERT>> Your code here.
  TRect boundsRect;

  int cx = Bounds.Width();
  int cy = Bounds.Height();
  if (cx > cy)
        {
        if (DrawOnVertBar == false)
           {
           int y1 = (cy - 2) / 2;
           DrawDividerLine(dc, 0, y1, cx, y1, true);
           DrawDividerLine(dc, 0, y1 + 1, cx, y1 + 1, false);
           /*boundsRect = TRect(0, y1, cx, cy - y1);
           #if defined(BI_PLAT_WIN16)
           TUIBorder(boundsRect, TUIBorder::TEdge(TUIBorder::SunkenOuter), TUIBorder::Bottom).Paint(dc);
           boundsRect.right++;
           TUIBorder(boundsRect, TUIBorder::TEdge(TUIBorder::SunkenOuter), TUIBorder::Top).Paint(dc);
           #elif defined(BI_PLAT_WIN32)
           TUIBorder(boundsRect, TUIBorder::TEdge(TUIBorder::SunkenOuter), TUIBorder::Top | TUIBorder::Bottom).Paint(dc);
           #endif*/
           }
        }
  else
     if (((IsEndOfRow() == false) || (DrawAtEndOfLine)) || (Window->GetDirection() != TGadgetWindow::Rectangular))
        {
        int x1 = (cx - 2) / 2;
        DrawDividerLine(dc, x1, 0, x1, cy, true);
        DrawDividerLine(dc, x1 + 1, 0, x1 + 1, cy, false);
/*        #if defined(BI_PLAT_WIN16)
        boundsRect = TRect(x1, 0, cx - x1, cy + 1);
        TUIBorder(boundsRect, TUIBorder::TEdge(TUIBorder::SunkenOuter), TUIBorder::TopLeft | TUIBorder::Right).Paint(dc);
        #elif defined(BI_PLAT_WIN32)
        boundsRect = TRect(x1, 0, cx - x1, cy);
        TUIBorder(boundsRect, TUIBorder::TEdge(TUIBorder::SunkenOuter), TUIBorder::Left | TUIBorder::Right).Paint(dc);
        #endif*/
        }
}

bool JPDividerGadget::GetEndOfLineStatus() const
{
    return DrawAtEndOfLine;
}

void JPDividerGadget::SetEndOfLineStatus(bool EndOfLine)
{
    DrawAtEndOfLine = EndOfLine;
}

bool JPDividerGadget::GetDrawOnVertBarStatus() const
{
    return DrawOnVertBar;
}

void JPDividerGadget::SetDrawOnVertBarStatus(bool NoVertBar)
{
    DrawOnVertBar = NoVertBar;
}

