/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.1  (April 7, 1998).                                                 *
*                                                                                    *
*  Definition of JPDividerGadget class.                                              *
*                                                                                    *
*  Read JPDIVGAD.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/
#if !defined(jpdivgad_h)              // Sentry, use file only if it's not already included.
#define jpdivgad_h

#if !defined(OWL_GADGET_H)
#include <owl/gadget.h>
#endif


//{{TGadget = JPDividerGadget}}
class JPDividerGadget : public TGadget {
  public:
    JPDividerGadget(int size = 0, int id = 0, bool EndOfLine = false, bool NoVertBar = false);
    virtual ~JPDividerGadget();

  protected:
    int   divSize;
    bool  DrawAtEndOfLine;
    bool  DrawOnVertBar;
    void  DrawDividerLine(TDC& dc, int x1, int y1, int x2, int y2, bool isFirst);

//{{JPDividerGadgetVIRTUAL_BEGIN}}
  public:
    virtual void GetDesiredSize(TSize& size);
    virtual void Paint(TDC& dc);
    virtual bool GetEndOfLineStatus() const;
    virtual void SetEndOfLineStatus(bool EndOfLine);
    virtual bool GetDrawOnVertBarStatus() const;
    virtual void SetDrawOnVertBarStatus(bool NoVertBar);
//{{JPDividerGadgetVIRTUAL_END}}
};    //{{JPDividerGadget}}

#endif  // jpdivgad_h sentry.

